<?php
/*
Plugin Name: Organizational post notifier
Description: Systém na upozorňování čtenářů na nepřečtené články. Vychází z OMN 1.3. <strong>Vyvinuto a určeno pro pure-heart.zaantar.eu</strong>
Version: 1.1
Author: Zaantar
Author URI: http://zaantar.eu
Plugin URI: http://zaantar.eu/index.php?page=organizational-post-notifier
License: GPL2
*/

/*
    Copyright 2011 Zaantar (email: zaantar@gmail.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as 
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

/*
	TODO
	- používání WLS
	- logování událostí
	- používání nonce
*/
/* ************************************************************************* *\
	INSTALLATION
\* ************************************************************************* */

register_activation_hook( __FILE__,'opn_plugin_activation' );

function opn_plugin_activation() {
	global $wpdb;
		
	$query_unread = 'CREATE TABLE IF NOT EXISTS '.$wpdb->prefix.'opn_unread (
		id INT NOT NULL AUTO_INCREMENT,
		post_id INT,
		user_id BIGINT(20),
		UNIQUE ( id ),
		PRIMARY KEY ( id )
	)';
	
	$wpdb->query( $wpdb->prepare( $query_unread ) );
}


function opn_log( $message ) {
	$filename = dirname(__FILE__).'/log.txt';

	$file = fopen( $filename, 'ä́' );
	if( is_user_logged_in() ) {
		$user = wp_get_current_user();
		$user = $user->user_login;
	} else {
		$user = '*visitor*';
	}
	$date = date( 'Y-m-d H:i:s' );
	
	$blogid = get_current_blog_id();
	switch_to_blog( $blogid );
	$blogname = get_bloginfo( 'siteurl' );
	restore_current_blog();
	fwrite( $file, '***  '.$date.', '.$user.' @ '.$blogid.' ('.$blogname.'):: '.$message."\n\n" );
	fclose( $file );
}


/* ************************************************************************* *\
	DATABASE
\* ************************************************************************* */

function opn_get_unread_posts( $user_id = 0 ) {
	global $wpdb;
	if( $user_id != 0 ) {
		$query = 'SELECT post_id
			FROM '.$wpdb->prefix.'opn_unread
			WHERE user_id = '.$user_id.'
			ORDER BY post_id ASC';
	} else {
		$query = 'SELECT post_id
			FROM '.$wpdb->prefix.'opn_unread
			GROUP BY post_id
			ORDER BY post_id ASC';
	}
	return $wpdb->get_col( $wpdb->prepare( $query ) );
}


function opn_get_nonreading_users( $post_id = 0 ) {
	global $wpdb;
	if( $post_id != 0 ) {
		$query = 'SELECT user_id
			FROM '.$wpdb->prefix.'opn_unread
			WHERE post_id = '.$post_id.'
			GROUP BY user_id';
	} else {
		$query = 'SELECT user_id
			FROM '.$wpdb->prefix.'opn_unread
			GROUP BY user_id';
	}
	return $wpdb->get_col( $wpdb->prepare( $query ) );
}


function opn_get_all_user_ids() {
	/*global $wpdb;
	$query = 'SELECT ID FROM '.$wpdb->prefix.'users';
	return $wpdb->get_col( $wpdb->prepare( $query ) );*/
	$user_query = new WP_User_Query( array( 'fields' => array( 'ID' ) ) );
	$usersdata = $user_query->get_results();
	$results = array();
	foreach( $usersdata as $userdata ) {
		$results[] = $userdata->ID;
	}
	return $results;
}


function opn_add_notification( $post_id, $user_id ) {
	global $wpdb;
	$wpdb->insert( $wpdb->prefix.'opn_unread', 
		array( 'post_id' => $post_id, 'user_id' => $user_id ),
		array( '%d', '%d' ) );
}


function opn_has_read( $post_id ) {
	global $wpdb;
	$query = 'SELECT COUNT(*)
		FROM '.$wpdb->prefix.'opn_unread
		WHERE (
			post_id = '.$post_id.'
			AND user_id = '.get_current_user_id().'
		)';
	$count = $wpdb->get_var( $wpdb->prepare( $query ) );
	if( $count == 0 ) {
		return true;
	} else {
		return false;
	}
}


function opn_read_post( $post_id ) {
	global $wpdb;
	$query = 'DELETE FROM '.$wpdb->prefix.'opn_unread
		WHERE (
			user_id = '.get_current_user_id().'
			AND post_id = '.$post_id.'
		)';
	$wpdb->query( $wpdb->prepare( $query ) );
}

function opn_delete_notification( $post_id, $user_id ) {
	global $wpdb;
	$query = 'DELETE FROM '.$wpdb->prefix.'opn_unread
		WHERE (
			user_id = '.$user_id.'
			AND post_id = '.$post_id.'
		)';
	$wpdb->query( $wpdb->prepare( $query ) );
}


/* ************************************************************************* *\
	ADMIN MENU & NOTICES
\* ************************************************************************* */


add_action( 'admin_menu','opn_admin_menu' );

function opn_admin_menu() {
	add_submenu_page( 'index.php', 'Přehled čtení článků', 'Přehled čtení článků', 'manage_options', 
		'opn-reading-overview', 'opn_reading_overview_page' );
}


function opn_nag( $message ) {
	echo( '<div id="message" class="updated"><p>'.$message.'</p></div>' );
}

function opn_nagerr( $message ) {
	echo( '<div id="message" class="error"><p>'.$message.'</p></div>' );
}


/* ************************************************************************* *\
	READING OVERVIEW
\* ************************************************************************* */


function opn_reading_overview_page() {   
	
	if( isset($_REQUEST['action']) ) {
        $action = $_REQUEST['action'];
    } else {
        $action = 'default';
    }
    
    switch( $action ) {
    case 'delete-notification':
    	opn_delete_notification( $_GET['post_id'], $_GET['user_id'] );
    	opn_reading_overview_page_default();
    	break;
    default:
    	opn_reading_overview_page_default();
    	break;
    }
}


function opn_reading_overview_page_default() {

	$post_ids = opn_get_unread_posts( 0 );
		
	?>
	<div class="wrap">
		<h2>Nepřečtené články</h2>
		<table class="widefat" cellspacing="0">
		    <thead>
		        <tr>
		            <th scope="col" class="manage-column">id</th>
		            <th scope="col" class="manage-column">Článek</th>
		            <th scope="col" class="manage-column">Autor<br />Datum</th>
		            <th scope="col" class="manage-column">Dosud nečetli</th>
				</tr>
			</thead>
			<tfoot>
				<tr>
		            <th scope="col" class="manage-column">id</th>
		            <th scope="col" class="manage-column">Zpráva</th>
		            <th scope="col" class="manage-column">Autor<br />Datum</th>
		            <th scope="col" class="manage-column">Dosud nečetli</th>
				</tr>
			</tfoot>
			<?php
				foreach( $post_ids as $post_id ) {
					$post = get_post( $post_id );
					$user_ids = opn_get_nonreading_users( $post_id );
					
					$user_string = '';
					$user_count = 0;
					foreach( $user_ids as $user_id ) {
						$userdata = get_userdata( $user_id );
						if( !empty( $user_string ) ) {
							$user_string .= ', ';
						}
						$user_string .= $userdata->user_login.' <a href="index.php?page=opn-reading-overview&action=delete-notification&user_id='.$user_id.'&post_id='.$post_id.'">&times;</a>';
						$user_count++;
					}
					if( $user_count > 0 ) {
						$user_string = $user_count.': '.$user_string;
					} else {
						$user_string = '(článek přečetli všichni adresáti)';
					}
					$authordata = get_userdata( $post->post_author );
					$title = '<a href="'.get_permalink( $post_id ).'">'.$post->post_title.'</a>';
					?>
					<tr>
						<td><?php echo $post_id; ?></td>
						<td><strong><?php echo $title; ?></strong></td>
						<td><?php echo $authordata->user_login.'<br />'.$post->post_date; ?></td>
						<td><?php echo $user_string; ?></td>
					</tr>
					<?php
				}
			?>
		</table>
	</div>
	<?php
}



/* ************************************************************************* *\
	ON NEW POST
\* ************************************************************************* */

add_action( 'publish_post', 'opn_publish_post' );

function opn_publish_post( $post_id ) {
	$user_ids = opn_get_all_user_ids();
	foreach( $user_ids as $user_id ) {
		opn_add_notification( $post_id, $user_id );
	}
}


/* ************************************************************************* *\
	READER NOTIFICATION
\* ************************************************************************* */

add_action( 'admin_notices', 'opn_admin_notices' );

function opn_admin_notices() {
	$unread = opn_get_unread_posts( get_current_user_id() );
	if( $unread == NULL ) {
		$count = 0;
	} else {
		$count = count( $unread );
	}
	if( $count > 0 ) {
		$url = get_permalink( $unread[0] );
		opn_nag( '<strong>Máte '.$count.' nepřečtených článků</strong>. Pro přečtení pokračujte, prosím, <a href="'.$url.'">sem</a>.' );
	}
}

add_action( 'admin_bar_menu', 'opn_admin_bar_menu' );

function opn_admin_bar_menu() { 
    global $wp_admin_bar;
	$unread = opn_get_unread_posts( get_current_user_id() );
	if( $unread == NULL ) {
		$count = 0;
	} else {
		$count = count( $unread );
	}
	if( $count > 0 ) {
		$wp_admin_bar->add_menu( array( 
			'id' => 'opn-notice',
			'title' => 'Máte '.$count.' nepřečtených článků! Klikněte zde pro přečtení.',
			'href' => get_permalink( $unread[0] )
		) );
	}
}


/* ************************************************************************* *\
	MARKING POST AS READ
\* ************************************************************************* */

add_action( 'comment_form_before', 'opn_comment_form_before' );

function opn_comment_form_before() {
	global $post;
	
	if( !is_user_logged_in() ) {
		return;
	}
	
	if( opn_has_read( $post->ID ) ) {
		return;
	}
	
	if( isset($_REQUEST['opn_action']) ) {
        $action = $_REQUEST['opn_action'];
    } else {
        $action = 'none';
    }
    
    if( $action == 'none' ) {
    	?>
    	<p>
			<form method="post" action="<?php echo get_permalink(); ?>">
				<input type="hidden" name="opn_action" value="read">
				<div style="text-align: center;">
					<input type="submit" id="submit" name="submit" value="Četl/a jsem celý tento článek." />
				</div>
			</form>
		</p>
    	<?
    } else if( $action == 'read' ) {
    	opn_read_post( $post->ID );
    }
}

?>
